//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// January 24, 2000
//
// Quick and dirty check of the copnvolution.
//
#include "slatec++.h"
#include <cmath>
#include <cassert>
#include <vector>
#include <algorithm>

int main() {

  const double eps = 1e-6;

  const unsigned n = 1024;
  const unsigned m = 32;

  const double s = 1.;
  const double r = 0.5;

  std::vector<double> signal(n);
  std::vector<double> response(n);
  std::vector<double> a(n);

  for(unsigned i = 0; i < n; i++){
    i < 1 ? signal[i] = s : signal[i] = 0;
    i < m ? response[i] = r : response[i] = 0;
  }
  
  a = Slatec::convolve(signal, response); // unnormalized
  for(unsigned i = 0; i < n; i++){
    i < m ? assert(fabs(a[i] - r) < eps) : assert(fabs(a[i]) < eps);
    std::cerr << i << " " << a[i] << std::endl;
  }    
}
