#include <iostream>
#include <cmath>
#include <cassert>
#include "slatec++.h"

namespace {
bool isClose(double a, double b)
{
    if (a == 0.)
        return fabs(b) < 1.e-10;

    return fabs(a)/fabs(b)-1. < 1.e-1;
}

double f(double x)
{
	return sin(x);
}

double F(double x)
{
    return -cos(x);
}
}

int main()
{
	Slatec::Curve<double> c(f);

	double a = 0.,
		   b = M_PI/2.;
	std::cout<<c.integral(a, b)<<std::endl;
	assert(isClose(c.integral(a, b), F(b)-F(a)));
}


