//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// January 07, 2000
//
#include <iostream>
#include <slatec.h>
#include <cmath>
#include <cstdlib>
#include <slatec++.h>
#include <cassert>

int main()
{

  int ncp = 4;
  int ndp = 20;
  float xd[ndp];
  float yd[ndp];
  float zd[ndp];
  int ndpi = 10;
  float xi[ndpi];
  float yi[ndpi];
  float zi[ndpi];
  float zi1[ndpi];

  int iwk[max(31,27+ncp)*ndp+ndpi];
  float wk[8*ndp];


  std::cout << "Input dataset: x-y-z" << std::endl;
  for(int i=0; i<ndp; i++){
    xd[i] = 0.3*i+static_cast<float>(rand())/RAND_MAX;
    yd[i] = 0.6*i;
    zd[i] = xd[i]+3*yd[i];
    std::cout << xd[i] << " " << yd[i] << " " << zd[i] << std::endl;
  }

  std::cout << "Interpolation grid: x-y-expected" << std::endl;
  for(int i=0; i<ndpi; i++){
    xi[i] = 0.5*i;//+static_cast<float>(rand())/RAND_MAX;
    yi[i] = 0.5*i;
    zi[i] = xi[i]+3*yi[i];
    std::cout << xi[i] << " " << yi[i] << " " << zi[i] << std::endl;
  }

  int md = 1;
  float zout;
  SLATEC_IDBVIP(md, ncp, ndp, xd, yd, zd, ndpi, &xd[0], &yd[0], &zout, iwk, wk);
  std::cout << ndpi << std::endl;
  md = 2;
  SLATEC_IDBVIP(md, ncp, ndp, xd, yd, zd, ndpi, xi, yi, zi1, iwk, wk);

  std::cout << ndpi << std::endl;
  std::cout << "Interpolation results: x-y-fabs(expected-calculated)" << std::endl;
//    for(int i=0; i<ndpi; i++){
//      cout << xi[i] << " " << yi[i] << " " << fabs(zi[i]-zi1[i]) << endl;
//    }
}
